const tar = require('tar');
const fetch = require('node-fetch');
const path = require('path');
const { readFile, writeFile } = require('fs-extra');
const getWritableDirectory = require('@now/build-utils/fs/get-writable-directory.js');
const { cli, commandInDir } = require('./cli');
const installRubyToolchain = require('./apt-install-ruby')

async function getRvm(dir) {
	console.log('downloading ruby.........')
  const rvmUrl = 'https://get.rvm.io'
  const res = await fetch(rvmUrl)

  if (!res.ok) {
    throw new Error(`Failed to download: ${rubyURL}`);
  }

  return new Promise((resolve, reject) => {
    console.log("In Promise")
    res.body
      .on('error', reject)
      .on('finish', content => resolve(writeFile(path.join(dir, 'rvm'), content))
  })
}

async function installRuby(dir) {
  const executor = commandInDir(dir)
  const rvmScript = path.join(dir, 'rvm')
  console.log('about to configure')
  await executor('chmod', '+x', rvmScript)
  // $ ./configure
  await executor(rvmScript, '-s', 'stable')

  await cli('rvm', 'install', '2.5.3')

  return cli('ruby', '-v')
}


module.exports = async (version = null) => {
  const dir = await getWritableDirectory()
  try {
    await installRubyToolchain()
    const rubyPath = await getRvm(dir)
    console.log('After download')
    const installedRubyVersion = await installRuby(rubyPath)
    console.log('After compile')
    console.log(`successfully installed Ruby with version ${installedRubyVersion}`)
  }
  catch (err){
    console.log(err)
    throw err
  }
}